/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : st_menu.cc
Last edit : 10/20/92
Created   :
Version   : 1.13

History   :

Does      : Stats-menu
*/
#include  <stdlib.h>
#include  <errno.h>
#include  <curses.h>
#include  <string.h>
#include  <ctype.h>
#include  <sys/types.h>
#include  <sys/stat.h>
#include  <unistd.h>

#include <paths.h>
#include <mcform.h>
#include <limits.h>

#include "st_opt.h"
#include "st.h"
#include "type.h"
#include "stat.h"
#include "cc_protot.h"

int stat_menu(char *dirri, char *name)
{
  role_stat 	a;
  int 		m=0;
  int 		i=0;
  int 		lvl=0;
  struct st_opt opts;
  int 		ok=0;
  int 		style = 1;
  int 		ext = 1;
  char 		puskuri[100]="";
  FILE 		*dst=NULL;
  int 		reroll=1;

  opts.gen_sty = 'o';
  opts.bon_sty = 's';
  opts.ext = 'y';
  siemen();
  if(chdir(dirri)) 
    if(mkdir(dirri,0755)) {
      printf("Unable to make directory\n");
      exit(0);
    } else
      chdir(dirri);

  m = ' ';
  clear();
  refresh();
  while(m != 'x') {
    put_st_main();
    m = getch();
    if(isupper(m))
      m = tolower(m);	
    switch(m) {
      case 'x':			/* Exit.*/
        return 0;
      case 'e':			/* Edit. */
	a.edit();
	printw(" ");
	refresh();
	clear();
	refresh();
	break;
      case 'a':			/* Raise. */
	if(access(".lvl",0)) {
	  dst = fopen(".lvl","r");
	  lvl = atoi(get_word(dst));
	  fclose(dst);
        }
        else 
	  lvl = 0;
	if(!access(".spent",0))
	  unlink(".spent");
	a.level(ext);
	lvl++;
	dst = fopen(".lvl","w");
	putw(lvl,dst);
        fclose(dst);
	printw(" ");
        refresh();
	clear();
	refresh();
        break;
      case 'l':			/* Load */
	a.load(name);
	move(23,0);
	printw("Stats loaded. Press any key to continue.");
	refresh();
	getch();
	move(23,0);
	clrtoeol();
	refresh();
	break;
      case 's':			/* Save */
	a.save(name);
	move(23,0);
	printw("Stats saved. Press any key to continue.");
	refresh();
	getch();
	move(23,0);
	clrtoeol();
	refresh();
	break;
      case 'p':			/* Place */
	a.place();
	printw(" ");
	refresh();
	clear();
	refresh();
	break;
      case 'k':			/* Peek */
	clear();
	refresh();
	a.print();
	move(23,0);
	printw("Press any key to continue!");
	refresh();
	getch();
	clear();
	refresh();
	break;
      case 'r':			/* Roll */
	clear();
	refresh();
	reroll = 1;
	while(reroll) {
	  switch(opts.gen_sty) {
	    case 'o':
	      a.ngen(style);
	      break;
	    case 'q':
	      a.qgen(style);
	      break;
	    case 'm':
	      a.mgen(style);
	      break;
	  }
	  move(23,0);
	  printw("Press r to reroll, others to continue.");
	  refresh();
	  m = getch();
	  if(m!='r')
	    reroll =0;
	};
	lvl = 0;
	dst = fopen(".lvl","w");
	putw(lvl,dst);
        fclose(dst);
        printw(" ");
        refresh();
        clear();
	refresh();
	break;
      case 'o':			/* Options. */
	dst = fopen(".opts","r");
	if(dst) {
	  fread(&opts,sizeof(struct st_opt),1,dst);
	  fclose(dst);
	}
	ok = 0;
        while(!ok) {
          put_st_opt(&opts);
	  get_st_opt(&opts);
          ok = 1;
	  if(isupper(opts.gen_sty))
	    opts.gen_sty = tolower(opts.gen_sty);
	  if(isupper(opts.bon_sty))
	    opts.bon_sty = tolower(opts.bon_sty);
	  if(isupper(opts.ext))
	    opts.ext = tolower(opts.ext);
          if(opts.ext != 'y' && opts.ext != 'n')
	    ok = 0;
          if(opts.bon_sty != 'o' && opts.bon_sty != 's' && opts.bon_sty !='l')
	    ok = 0;
          if(opts.gen_sty != 'o' && opts.gen_sty != 'q' && opts.gen_sty !='m')
	    ok = 0;
        }
	switch(opts.bon_sty) {
	  case 'o':
	    style = 0;
	    break;
	  case 's':
	    style = 1;
	    break;
	  case 'l':
	    style = 2;
	    break;
	}
        if(opts.ext == 'y') ext = 1;
	dst = fopen(".opts","w");
	if(dst) {
	  fwrite(&opts,sizeof(struct st_opt),1,dst);
	  fclose(dst);
	}
	printw(" ");
	refresh();
	clear();
	refresh();	
	break;		
      default:
	break;
    }		
  }
  return 0;
}

/* Raise stats on name, one level. Current level in filename. */
void do_raise(char *name, char *filename)
{
  role_stat 	rt;
  FILE 		*dst=NULL;
  int 		lvl=0;

  falku();
  rt.load(name);
  dst = fopen(filename,"r");
  if(dst) {
    lvl = getw(dst);
    fclose(dst);
  } 
  else
    perror(filename);
  rt.level(1,lvl,lvl+1);
  rt.save(name);
  lvl++;
  dst = fopen(filename,"w");
  if(dst) {
    putw(lvl,dst);
    fclose(dst);
  }
  else 
    perror(filename);
  printw(" ");
  refresh();
  clear();
  refresh();
  floppu();
}

